﻿package MT::Plugin::UISample;
use strict;
use MT;

@MT::Plugin::UISample::ISA = qw(MT::Plugin);

my $plugin = new MT::Plugin::UISample({
    description => 'User interface sample plugin.',
    name => 'UISample',
    author_name => 'Junnama Noda',
    author_link => 'http://junnama.alfasado.net/online/',
    version => 0.1,
});

MT->add_plugin($plugin);

sub init_registry {
    my $plugin = shift;
    $plugin->registry({
        applications => {
            cms => {
                menus => {
                    'create:ui_sample_dialog' => {
                        label  => 'My Dialog',
                        dialog => 'ui_sample_dialog',
                        order  => 101,
                        permission => 'create_post',
                    },
                    'tools:ui_sample_page' => {
                        label => 'My Page',
                        mode  => 'ui_sample_page',
                        order => 201,
                        permission => 'create_post',
                    },
                },
                methods => {
					ui_sample_dialog =>
					    'MT::Plugin::UISample::ui_sample_dialog',
				    ui_sample_page =>
					    'MT::Plugin::UISample::ui_sample_page',
				},
            },
        },
        widgets => {
            ui_sample_widgets => {
                label    => 'UI Sample Widget',
                plugin   => $plugin,
                template => 'sample_widgets.mtml',
                set => 'sidebar',
                singular => 1,
				condition => sub {
					my ($page, $scope) = @_;
					return $page eq 'dashboard';
				},
            },
        },
   });
}

sub ui_sample_dialog {
    my $app = shift;
    # ここで何らかの処理を行う
    # どのテンプレートを使うかを定義する
    $app->{plugin_template_path} = File::Spec->catdir($plugin->path,'tmpl');
    my $tmpl = 'dialog.tmpl';
    # ダイアログに表示するパラメタをセットする
    my %param;    
    $param{'page_title'} = 'ダイアログのサンプル';
    # ページをBuildして表示する
    return $app->build_page($tmpl, \%param);
}

sub ui_sample_page {
    my $app = shift;
    $app->{plugin_template_path} = File::Spec->catdir($plugin->path,'tmpl');
    my $tmpl = 'page.tmpl';
    my %param;
    $param{'page_title'} = 'ページのサンプル';
    $param{'page_msg'} = 'ページのサンプルを表示しています。';
    return $app->build_page($tmpl, \%param);
}

1;